"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const sfpowerkit_1 = require("../../../../src/sfpowerkit");
class BaseMetadataRetriever {
    constructor(org, tooling = false) {
        this.org = org;
        this.tooling = tooling;
        this.isLimitBasedQueryRetrieval = false;
        this.dataLoaded = false;
        this.cacheFileName = "";
    }
    setCountQuery(countQuery, limit) {
        this.isLimitBasedQueryRetrieval = true;
        this.countQuery = countQuery;
        this.limit = limit;
    }
    setQuery(query) {
        this.query = query;
        if (this.isLimitBasedQueryRetrieval)
            this.queryWithOffsetsAndLimit = this.query.concat(` LIMIT ${this.limit} OFFSET 0`);
    }
    async getObjects() {
        let records = [];
        const conn = this.org.getConnection();
        // Not Limit and Offset, based so old method
        if (!this.isLimitBasedQueryRetrieval) {
            sfpowerkit_1.SFPowerkit.ux.log(`Method: isTooling :  ${this.tooling}, QUERY:  ${this.query}`);
            let result;
            // Query the org
            if (this.tooling) {
                result = await conn.tooling.query(this.query);
            }
            else {
                result = await conn.query(this.query);
            }
            records.push(...result.records);
            while (!result.done) {
                result = await this.queryMore(result.nextRecordsUrl);
                records.push(...result.records);
            }
        }
        else {
            sfpowerkit_1.SFPowerkit.ux.log(`Method: isToolingandLimitBasedQueryRetrieval : true, QUERY:  ${this.query}`);
            let retrievedRecordSize = 0;
            let offset = 0;
            this.totalSize = await this.getCount();
            while (retrievedRecordSize < this.totalSize) {
                sfpowerkit_1.SFPowerkit.ux.log(`To Retrieve Total Size:  ${this.totalSize},Retrieved Size:   ${retrievedRecordSize} , Current Offset: ${offset}`);
                let result;
                sfpowerkit_1.SFPowerkit.ux.log(this.queryWithOffsetsAndLimit);
                result = await conn.tooling.query(this.queryWithOffsetsAndLimit);
                retrievedRecordSize += result.totalSize;
                records.push(...result.records);
                offset++;
                this.queryWithOffsetsAndLimit = this.query.concat(` LIMIT ${this.limit} OFFSET ${offset}`);
            }
        }
        return records;
    }
    async queryMore(url) {
        const conn = this.org.getConnection();
        let result;
        if (this.tooling) {
            result = await conn.tooling.queryMore(url);
        }
        else {
            result = await conn.queryMore(url);
        }
        return result;
    }
    async getCount() {
        sfpowerkit_1.SFPowerkit.ux.log(`Count Query: ${this.countQuery}`);
        let result = await this.org.getConnection().tooling.query(this.countQuery);
        sfpowerkit_1.SFPowerkit.ux.log(`Retrieved count ${result.totalSize}`);
        return result.totalSize;
    }
}
exports.default = BaseMetadataRetriever;
//# sourceMappingURL=baseMetadataRetriever.js.map